/* AT&T DSP16, 8th order 4-mult IIR Fltr   jkf 10/14/88 */
/*							*/
/*  DSP16 8th order 4-multiply benchmark IIR filter.    */
/*  Implementation is Direct Form II.	4iir8.s		*/
/*							*/
/*  Execution requires 46 cycles/sample. 		*/
/*    (2.53us per sample; sample rate = 395 KHz @ 55ns).*/
/*    (1.52us per sample; sample rate = 659 KHz @ 33ns).*/
/*							*/
/*  Rom requirements are:				*/
/*		Program		17 words		*/
/*		Coefficients	16 words		*/
/*							*/
/*  Ram requirement is:		8 words			*/
/*						*/
/*  Implementation is a cascade of 4 SOS's. 	*/
/*  I/O is included in benchmark program.	*/
/*  Inputs (16-bit linear) enter via pdx0.     	*/
/*  Outputs (16-bit linear) are sent to pdx1.	*/
/*						*/

/*    The IIR coding example uses the following       */
/*  DSP16 resources:                                  */
/*                                                    */
/*          a0: input/output for each section               */
/*          r1: state variable pointer                      */
/*          pt: pointer to filter coefficients              */
/*          j, k:   for special compound addressing mode    */
/*                                                          */
/*  This coding example demonstrates the use of compound addressing */
/*  for maintaining the state variable delay line.                  */

4iir8:  auc=0x2
        j=-2		/* j and k are used for register 	*/
        k=3		/* in compound addressing (see manual).	*/
loop:   pt=d11		/* pt points to coefficients in ROM.	*/
        r1=P01		/* r1 points to tap outputs in RAM.	*/
        a0=pdx0		/* Input sample from parallel port0.	*/

	              y=*r1++ x=*pt++	/* d11	*/
	        p=x*y y=*r1-- x=*pt++	/* d21	*/
	do 4 {
	a0=a0+p p=x*y y=*r1++ x=*pt++	/* n1(n) */
	a0=a0+p p=x*y *r1zp:y x=*pt++	/* n2(n) */
	a0=p    p=x*y y=a0 x=*pt++	/* d1(n+1) */
	a0=a0+y       *r1jk:y
	a0=a0+p p=x*y y=*r1-- x=*pt++	/* d2(n+1) */
	}
	pdx1=a0
endl:	goto loop


d11:	int	0.834961
d21:	int	-0.276733
n11:	int	0.199661
n21:	int	0.120941
d12:	int	0.587860
d22:	int	-0.578308
n12:	int	0.196716
n22:	int	0.393021
d13:	int	1.815369
d23:	int	-0.829651
n13:	int	-1.855103
n23:	int	0.927673
d14:	int	0.485077
d24:	int	-0.872253
n14:	int	0.029175
n24:	int	0.631042

.rdm
P01:	int
P11:	int
P02:	int
P12:	int
P03:	int
P13:	int
P04:	int
P14:	int
.endrdm


